{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003,2004,2005 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
unit config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, Registry, ExtCtrls, ComCtrls;

type
  Topm_Form_Config = class(TForm)
    opm_BitBtn_ConfigOk: TBitBtn;
    opm_BitBtn_ConfigCancel: TBitBtn;
    opm_PageControl_Config: TPageControl;
    opm_TabSheet_ConfigNet: TTabSheet;
    opm_GroupBox_DB: TGroupBox;
    opm_Label_ConfigHost: TLabel;
    opm_Label_ConfigPassword: TLabel;
    opm_Label_ConfigPort: TLabel;
    opm_Label_ConfigUsername: TLabel;
    opm_Label_ConfigDatabase: TLabel;
    opm_Label_ConfigProtocol: TLabel;
    opm_Edit_ConfigPassword: TEdit;
    opm_ComboBox_ConfigProtocol: TComboBox;
    opm_SpinEdit_ConfigPort: TSpinEdit;
    opm_ComboBox_ConfigHost: TComboBox;
    opm_ComboBox_ConfigDatabase: TComboBox;
    opm_ComboBox_ConfigUsername: TComboBox;
    opm_CheckBox_ConfigCompress: TCheckBox;
    opm_TabSheet_ConfigUI: TTabSheet;
    opm_GroupBox_inter: TGroupBox;
    Bevel4: TBevel;
    opm_CheckBox_ConfigRemember: TCheckBox;
    opm_CheckBox_ConfigHotTrack: TCheckBox;
    opm_CheckBox_ConfigAutoload: TCheckBox;
    opm_CheckBox_ConfigDragDrop: TCheckBox;
    opm_CheckBox_ConfigTooltips: TCheckBox;
    opm_CheckBox_ConfigSilent: TCheckBox;
    opm_TabSheet_ConfigImg: TTabSheet;
    opm_GroupBox_img: TGroupBox;
    opm_Label_ConfigImageURL: TLabel;
    opm_ComboBox_ConfigImgURL: TComboBox;
    opm_Edit_ConfigUploadPassword: TEdit;
    opm_Label_ConfigUploadPassword: TLabel;
    opm_ComboBox_ConfigUploadURL: TComboBox;
    opm_Label_ConfigUploadURL: TLabel;
    opm_GroupBox_ImgConv: TGroupBox;
    opm_CheckBox_ConfigResizeImg: TCheckBox;
    opm_Label_ConfigImgResize: TLabel;
    opm_SpinEdit_ConfigImgX: TSpinEdit;
    opm_SpinEdit_ConfigImgY: TSpinEdit;
    Label1: TLabel;
    opm_SpinEdit_ConfigImgQ: TSpinEdit;
    opm_Label_ConfigImgJPEGQuality: TLabel;
    opm_OpenDialog_ConfigINI: TOpenDialog;
    opm_SaveDialog_ConfigINI: TSaveDialog;
    opm_GroupBox_inter2: TGroupBox;
    opm_BitBtn_ConfigReset: TBitBtn;
    Bevel2: TBevel;
    opm_CheckBox_ConfigDragUps: TCheckBox;
    opm_CheckBox_ConfigConfirmDels: TCheckBox;
    opm_CheckBox_ConfigConfirmDrag: TCheckBox;
    opm_CheckBox_ConfigConfirmMods: TCheckBox;
    opm_CheckBox_ConfigConfirmUps: TCheckBox;
    opm_CheckBox_ConfigAutoDownImg: TCheckBox;
    opm_CheckBox_ConfigNoCacheImg: TCheckBox;
    Bevel1: TBevel;
    opm_CheckBox_ConfigConfirmExit: TCheckBox;
    opm_CheckBox_ConfigConfirmImgDels: TCheckBox;
    opm_CheckBox_ConfigSmartRename: TCheckBox;
    opm_Label_ConfigJPEGQCategory: TLabel;
    opm_TabSheet_ConfigMods: TTabSheet;
    opm_GroupBox_Mods: TGroupBox;
    opm_Edit_ConfigModCmd: TEdit;
    opm_Label_ConfigModIndex: TLabel;
    opm_ComboBox_ConfigModIndex: TComboBox;
    opm_ComboBox_ConfigModResult: TComboBox;
    opm_Label_ConfigModResult: TLabel;
    opm_Label_ConfigModFile: TLabel;
    opm_SpinEdit_ConfigModPort: TSpinEdit;
    opm_Label_ConfigModPort: TLabel;
    opm_Label_ConfigModName: TLabel;
    opm_Edit_ConfigModName: TEdit;
    opm_ListBox_ConfigMods: TListBox;
    opm_BitBtn_ConfigModSave: TBitBtn;
    opm_BitBtn_ConfigModDel: TBitBtn;
    opm_CheckBox_ConfigModRemote: TCheckBox;
    opm_CheckBox_ConfigModJustRun: TCheckBox;
    opm_CheckBox_ConfigModOnSelection: TCheckBox;
    opm_BitBtn_ConfigModClean: TBitBtn;
    opm_Edit_ConfigModPara: TEdit;
    opm_Label_ConfigModPara: TLabel;
    opm_BitBtn_ConfigModFile: TBitBtn;
    opm_OpenDialog_ConfigMod: TOpenDialog;
    opm_CheckBox_ConfigPaddingImg: TCheckBox;
    opm_CheckBox_ConfigKeepARImg: TCheckBox;
    opm_BitBtn_ConfigColSel: TBitBtn;
    opm_Panel_ConfigColSel: TPanel;
    opm_TabSheet_ConfigNet2: TTabSheet;
    opm_GroupBox_HTTP: TGroupBox;
    opm_Label_ConfigPHost: TLabel;
    opm_Label_ConfigPPort: TLabel;
    opm_ComboBox_ConfigProxyHost: TComboBox;
    opm_SpinEdit_ConfigProxyPort: TSpinEdit;
    opm_CheckBox_ConfigStorePass: TCheckBox;
    opm_GroupBox_SSH: TGroupBox;
    opm_Label_ConfigSSHPassword: TLabel;
    opm_Label_ConfigSSHPort: TLabel;
    opm_Label_ConfigSSHUsername: TLabel;
    opm_Edit_ConfigSSHPassword: TEdit;
    opm_SpinEdit_ConfigSSHLocalPort: TSpinEdit;
    opm_ComboBox_ConfigSSHUsername: TComboBox;
    opm_CheckBox_ConfigUseSSH: TCheckBox;
    opm_GroupBox_INI: TGroupBox;
    opm_BitBtn_ConfigLoadINI: TBitBtn;
    opm_BitBtn_ConfigSaveINI: TBitBtn;
    opm_BitBtn_ConfigProxyIE: TBitBtn;
    opm_BitBtn_ConfigTestSSH: TBitBtn;
    opm_TabSheet_ConfigUI2: TTabSheet;
    opm_GroupBox_Lang: TGroupBox;
    opm_Label_ConfigUILang: TLabel;
    opm_ComboBox_ConfigUILang: TComboBox;
    opm_Label_ConfigUILangDesc: TLabel;
    Bevel3: TBevel;
    opm_FontDialog_Config: TFontDialog;
    opm_GroupBox_Font: TGroupBox;
    opm_BitBtn_ConfigFont: TBitBtn;
    opm_Label_ConfigFontDetails: TLabel;
    opm_SpinEdit_ConfigSSHConnWait: TSpinEdit;
    opm_Label_ConfigSSHConnWait: TLabel;
    opm_Label_ConfigDBConnWait: TLabel;
    opm_SpinEdit_ConfigDBConnWait: TSpinEdit;
    opm_CheckBox_ConfigUseProxy: TCheckBox;
    opm_TabSheet_ConfigDBDetail: TTabSheet;
    opm_GroupBox_DBDetails: TGroupBox;
    opm_Label_ConfigDBTable01: TLabel;
    opm_Edit_ConfigDBTable01: TEdit;
    opm_Edit_ConfigDBTable02: TEdit;
    opm_Label_ConfigDBTable02: TLabel;
    opm_Edit_ConfigDBTable04: TEdit;
    opm_Label_ConfigDBTable04: TLabel;
    opm_Edit_ConfigDBTable03: TEdit;
    opm_Label_ConfigDBTable03: TLabel;
    opm_Label_ConfigDBTable05: TLabel;
    opm_Edit_ConfigDBTable05: TEdit;
    opm_Label_ConfigDBTable06: TLabel;
    opm_Edit_ConfigDBTable06: TEdit;
    opm_Label_ConfigDBTable07: TLabel;
    opm_Edit_ConfigDBTable07: TEdit;
    opm_Label_ConfigDBTable08: TLabel;
    opm_Edit_ConfigDBTable08: TEdit;
    opm_Label_ConfigDBTable09: TLabel;
    opm_Edit_ConfigDBTable09: TEdit;
    opm_Label_ConfigDBTable10: TLabel;
    opm_Edit_ConfigDBTable10: TEdit;
    opm_Label_ConfigDBTable11: TLabel;
    opm_Edit_ConfigDBTable11: TEdit;
    opm_Label_ConfigDBTable13: TLabel;
    opm_Edit_ConfigDBTable13: TEdit;
    opm_BitBtn_ConfigDBReset: TBitBtn;
    opm_CheckBox_ConfigDBDebugLog: TCheckBox;
    opm_Label_ConfigDBTablesDesc: TLabel;
    opm_CheckBox_ConfigAllowZeroPrice: TCheckBox;
    opm_CheckBox_ConfigDBDebug: TCheckBox;
    opm_CheckBox_ConfigWBDebug: TCheckBox;
    opm_CheckBox_ConfigSSHDebug: TCheckBox;
    opm_CheckBox_ConfigAllowNegativeQuantity: TCheckBox;
    opm_Label_ConfigDBConnRetries: TLabel;
    opm_SpinEdit_ConfigDBConnRetries: TSpinEdit;
    opm_PRNFontDialog_Config: TFontDialog;
    opm_TabSheet_ConfigPRN: TTabSheet;
    opm_GroupBox_PRNFont: TGroupBox;
    opm_Label_ConfigPRNFontDetails: TLabel;
    opm_BitBtn_ConfigFontPrint: TBitBtn;
    opm_Label_ConfigPRNMaxChars: TLabel;
    opm_SpinEdit_ConfigPRNColSize: TSpinEdit;
    opm_CheckBox_ConfigPRNLandscape: TCheckBox;
    Bevel5: TBevel;
    procedure FormShow(Sender: TObject);
    procedure opm_BitBtn_ConfigOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure opm_BitBtn_ConfigResetClick(Sender: TObject);
    procedure opm_CheckBox_ConfigResizeImgClick(Sender: TObject);
    procedure opm_BitBtn_ConfigSaveINIClick(Sender: TObject);
    procedure opm_BitBtn_ConfigLoadINIClick(Sender: TObject);
    procedure opm_SpinEdit_ConfigImgQChange(Sender: TObject);
    procedure opm_BitBtn_ConfigModSaveClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModLoadClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModDelClick(Sender: TObject);
    procedure opm_ListBox_ConfigModsClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModCleanClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModFileClick(Sender: TObject);
    procedure opm_BitBtn_ConfigColSelClick(Sender: TObject);
    procedure opm_CheckBox_ConfigUseSSHClick(Sender: TObject);
    procedure opm_BitBtn_ConfigProxyIEClick(Sender: TObject);
    procedure opm_BitBtn_ConfigTestSSHClick(Sender: TObject);
    procedure opm_BitBtn_ConfigFontClick(Sender: TObject);
    procedure opm_CheckBox_ConfigUseProxyClick(Sender: TObject);
    procedure opm_BitBtn_ConfigDBResetClick(Sender: TObject);
    procedure opm_BitBtn_ConfigFontPrintClick(Sender: TObject);
  private
    PROCEDURE PRopm_ControlToVars;
    procedure PRopm_VarsToControls;
    PROCEDURE opm_PRRefresh_ModuleList (LastIndex : INTEGER);
  public
  end;

var
  opm_Form_Config: Topm_Form_Config;

implementation

{$R *.dfm}

Uses gnugettext, oscpmdata, main, balloons, regconfig, attention, imageman, modules, dataman,
     colorsel, network;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.PRopm_VarsToControls;
VAR
  UILang : LONGINT;
begin
  opm_ComboBox_ConfigHost.Text := opmG_DBHost;
  opm_ComboBox_ConfigDatabase.Text := opmG_DBDatabase;
  opm_Edit_ConfigDBTable01.Text := opmG_DBTable_Categories;
  opm_Edit_ConfigDBTable02.Text := opmG_DBTable_Manufacturers;
  opm_Edit_ConfigDBTable03.Text := opmG_DBTable_Languages;
  opm_Edit_ConfigDBTable04.Text := opmG_DBTable_Products;
  opm_Edit_ConfigDBTable05.Text := opmG_DBTable_Specials;
  opm_Edit_ConfigDBTable06.Text := opmG_DBTable_ProductsDescription;
  opm_Edit_ConfigDBTable07.Text := opmG_DBTable_TaxClass;
  opm_Edit_ConfigDBTable08.Text := opmG_DBTable_Currencies;
  opm_Edit_ConfigDBTable09.Text := opmG_DBTable_Configuration;
  opm_Edit_ConfigDBTable10.Text := opmG_DBTable_ProductsToCategories;
  opm_Edit_ConfigDBTable11.Text := opmG_DBTable_CategoriesDescription;
  opm_Edit_ConfigDBTable13.Text := opmG_DBTable_TaxRates;
  opm_ComboBox_ConfigUsername.Text := opmG_DBUsername;
  opm_ComboBox_ConfigImgURL.Text := opmG_WBImgURL;
  opm_ComboBox_ConfigUploadURL.Text := opmG_WBUploadURL;
  opm_ComboBox_ConfigHost.Items := opmG_PastHost_BoxList;
  opm_ComboBox_ConfigDatabase.Items := opmG_PastDatabase_BoxList;
  opm_ComboBox_ConfigUsername.Items := opmG_PastUsername_BoxList;
  opm_ComboBox_ConfigSSHUsername.Items := opmG_PastSSHUsername_BoxList;
  opm_ComboBox_ConfigImgURL.Items := opmG_PastImgURL_BoxList;
  opm_ComboBox_ConfigUploadURL.Items := opmG_PastUploadURL_BoxList;
  opm_Edit_ConfigUploadPassword.Text := opmG_UploadPassword;
  opm_ComboBox_ConfigProxyHost.Items := opmG_PastProxy_BoxList;
  opm_ComboBox_ConfigProxyHost.Text := opmG_WBProxyHost;
  opm_Edit_ConfigPassword.Text := opmG_DBPassword;
  opm_ComboBox_ConfigProtocol.Text := opmG_DBProtocol;
  opm_SpinEdit_ConfigPort.Value := opmG_DBPort;
  opm_SpinEdit_ConfigProxyPort.Value := opmG_WBProxyPort;
  opm_SpinEdit_ConfigDBConnWait.Value := opmG_DBConnWait;
  opm_SpinEdit_ConfigSSHConnWait.Value := opmG_SSHConnWait;
  opm_SpinEdit_ConfigDBConnRetries.Value := opmG_DBConnRetries;
  opm_SpinEdit_ConfigImgX.Value := opmG_WBImgX;
  opm_SpinEdit_ConfigImgY.Value := opmG_WBImgY;
  opm_SpinEdit_ConfigImgQ.Value := opmG_WBImgQ;
  opm_Label_ConfigJPEGQCategory.Caption := FNopm_QualityExplain (opmG_WBImgQ);
  opm_Panel_ConfigColSel.Color := FNopm_DecColorToColor (opmG_WBPaddingColor);
  opm_Panel_ConfigColSel.Caption := FNopm_ColorToRGB (opm_Panel_ConfigColSel.Color);
  opm_PageControl_Config.ActivePageIndex := 0;
  IF (opmG_UIHotTracking > 0) THEN opm_CheckBox_ConfigHotTrack.Checked := TRUE ELSE opm_CheckBox_ConfigHotTrack.Checked := FALSE;
  IF (opmG_UIRememberDisplay > 0) THEN opm_CheckBox_ConfigRemember.Checked := TRUE ELSE opm_CheckBox_ConfigRemember.Checked := FALSE;
  IF (opmG_UIClickLoad > 0) THEN opm_CheckBox_ConfigAutoload.Checked := TRUE ELSE opm_CheckBox_ConfigAutoload.Checked := FALSE;
  IF (opmG_UIDragDrop > 0) THEN opm_CheckBox_ConfigDragDrop.Checked := TRUE ELSE opm_CheckBox_ConfigDragDrop.Checked := FALSE;
  IF (opmG_UIToolTips > 0) THEN opm_CheckBox_ConfigTooltips.Checked := TRUE ELSE opm_CheckBox_ConfigTooltips.Checked := FALSE;
  IF (opmG_DBCompress > 0) THEN opm_CheckBox_ConfigCompress.Checked := TRUE ELSE opm_CheckBox_ConfigCompress.Checked := FALSE;
  IF (opmG_UseProxy > 0) THEN opm_CheckBox_ConfigUseProxy.Checked := TRUE ELSE opm_CheckBox_ConfigUseProxy.Checked := FALSE;
  IF (opmG_UseSSH > 0) THEN opm_CheckBox_ConfigUseSSH.Checked := TRUE ELSE opm_CheckBox_ConfigUseSSH.Checked := FALSE;
  opm_SpinEdit_ConfigSSHLocalPort.Value := opmG_SSHLocalPort;
  opm_ComboBox_ConfigSSHUsername.Text := opmG_SSHUsername;
  opm_Edit_ConfigSSHPassword.Text := opmG_SSHPassword;
  IF (opmG_DBStorePass > 0) THEN opm_CheckBox_ConfigStorePass.Checked := TRUE ELSE opm_CheckBox_ConfigStorePass.Checked := FALSE;
  IF (opmG_UISilent > 0) THEN opm_CheckBox_ConfigSilent.Checked := TRUE ELSE opm_CheckBox_ConfigSilent.Checked := FALSE;
  IF (FNopm_CheckSound = TRUE) THEN opm_CheckBox_ConfigSilent.Enabled := TRUE ELSE opm_CheckBox_ConfigSilent.Enabled := FALSE;
  IF (opmG_UIConfirmDels > 0) THEN opm_CheckBox_ConfigConfirmDels.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmDels.Checked := FALSE;
  IF (opmG_UIConfirmDrag > 0) THEN opm_CheckBox_ConfigConfirmDrag.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmDrag.Checked := FALSE;
  IF (opmG_UIConfirmMods > 0) THEN opm_CheckBox_ConfigConfirmMods.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmMods.Checked := FALSE;
  IF (opmG_UIAllowZeroPrice > 0) THEN opm_CheckBox_ConfigAllowZeroPrice.Checked := TRUE ELSE opm_CheckBox_ConfigAllowZeroPrice.Checked := FALSE;
  IF (opmG_UIAllowNegativeQuantity > 0) THEN opm_CheckBox_ConfigAllowNegativeQuantity.Checked := TRUE ELSE opm_CheckBox_ConfigAllowNegativeQuantity.Checked := FALSE;
  IF (opmG_UIAutoDownImg > 0) THEN opm_CheckBox_ConfigAutoDownImg.Checked := TRUE ELSE opm_CheckBox_ConfigAutoDownImg.Checked := FALSE;
  opm_FontDialog_Config.Font.Name := opmG_UIFontName;
  opm_FontDialog_Config.Font.Height := opmG_UIFontHeight;
  opm_FontDialog_Config.Font.Charset := opmG_UIFontCharset;
  opm_FontDialog_Config.Font.Style := opmC_DefaultFontStyle;
  opm_Label_ConfigFontDetails.Font := opm_FontDialog_Config.Font;
  opm_Label_ConfigFontDetails.Caption := opmG_UIFontName + ', ' +
                                         INTTOSTR (ROUND ((opmG_UIFontHeight * -72) / opm_FontDialog_Config.Font.PixelsPerInch)) + ', ' +
                                         opmG_CharsetList [opmG_UIFontCharset];
  opm_PRNFontDialog_Config.Font.Name := opmG_PRNFontName;
  opm_PRNFontDialog_Config.Font.Height := ROUND ((opmG_PRNFontSize * opm_PRNFontDialog_Config.Font.PixelsPerInch) / -72);
  opm_PRNFontDialog_Config.Font.Charset := opmG_PRNFontCharset;
  opm_PRNFontDialog_Config.Font.Style := opmC_Def_PRNFontStyle;
  opm_Label_ConfigPRNFontDetails.Font := opm_PRNFontDialog_Config.Font;
  opm_Label_ConfigPRNFontDetails.Caption := opmG_PRNFontName + ', ' + INTTOSTR (opmG_PRNFontSize) + ', ' + opmG_CharsetList [opmG_PRNFontCharset];
  opm_SpinEdit_ConfigPRNColSize.Value := opmG_PRNColSize;
  IF (opmG_PRNLandscape > 0) THEN opm_CheckBox_ConfigPRNLandscape.Checked := TRUE ELSE opm_CheckBox_ConfigPRNLandscape.Checked := FALSE;
  IF (opmG_WBNoCacheImg > 0) THEN opm_CheckBox_ConfigNoCacheImg.Checked := TRUE ELSE opm_CheckBox_ConfigNoCacheImg.Checked := FALSE;
  IF (opmG_WBResizeImg > 0) THEN opm_CheckBox_ConfigResizeImg.Checked := TRUE ELSE opm_CheckBox_ConfigResizeImg.Checked := FALSE;
  IF (opmG_WBPaddingImg > 0) THEN opm_CheckBox_ConfigPaddingImg.Checked := TRUE ELSE opm_CheckBox_ConfigPaddingImg.Checked := FALSE;
  IF (opmG_WBKeepARImg > 0) THEN opm_CheckBox_ConfigKeepARImg.Checked := TRUE ELSE opm_CheckBox_ConfigKeepARImg.Checked := FALSE;
  IF (opmG_WBSmartRename > 0) THEN opm_CheckBox_ConfigSmartRename.Checked := TRUE ELSE opm_CheckBox_ConfigSmartRename.Checked := FALSE;
  IF (opmG_UIConfirmExit > 0) THEN opm_CheckBox_ConfigConfirmExit.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmExit.Checked := FALSE;
  IF (opmG_DBDebugLog > 0) THEN opm_CheckBox_ConfigDBDebugLog.Checked := TRUE ELSE opm_CheckBox_ConfigDBDebugLog.Checked := FALSE;
  IF (opmG_UIDBDebug > 0) THEN opm_CheckBox_ConfigDBDebug.Checked := TRUE ELSE opm_CheckBox_ConfigDBDebug.Checked := FALSE;
  IF (opmG_UISSHDebug > 0) THEN opm_CheckBox_ConfigSSHDebug.Checked := TRUE ELSE opm_CheckBox_ConfigSSHDebug.Checked := FALSE;
  IF (opmG_UIWBDebug > 0) THEN opm_CheckBox_ConfigWBDebug.Checked := TRUE ELSE opm_CheckBox_ConfigWBDebug.Checked := FALSE;
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    FOR UILang := 0 TO opm_ComboBox_ConfigUILang.Items.Count DO
      IF (POS ('(' + opmG_UIGUILang + ')', opm_ComboBox_ConfigUILang.Items[UILang]) > 0) THEN
        BEGIN
          opm_ComboBox_ConfigUILang.ItemIndex := UILang;
          BREAK;
        END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.FormShow(Sender: TObject);
BEGIN
  opm_Form_Config.Caption := _('Settings of ') + opmC_AppShortName;
  opm_ComboBox_ConfigUILang.Items.Clear;
  DefaultInstance.GetListOfLanguages ('default', opm_ComboBox_ConfigUILang.Items);
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    BEGIN
      DefaultInstance.BindtextdomainToFile ('isotolanguagenames', ExtractFilePath (Application.Exename) + 'locale/isotolanguagenames.mo');
      DefaultInstance.TranslateProperties (opm_ComboBox_ConfigUILang, 'isotolanguagenames');
      opm_ComboBox_ConfigUILang.Enabled := TRUE;
    END
  ELSE
    opm_ComboBox_ConfigUILang.Enabled := FALSE;
  opm_Label_ConfigUILangDesc.Caption := _('Do you want to contribute with a translation in your native language?') + #13#10 +
                                        _('It is very easy, and you don''t have to be a programmer to do it.') + #13#10 +
                                        _('Please visit the website for more information.');
  PRopm_VarsToControls;
  opm_Label_ConfigImgResize.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigPaddingImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigKeepARImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgX.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgY.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Panel_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_BitBtn_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgQ.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigImgJPEGQuality.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigJPEGQCategory.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_ComboBox_ConfigProxyHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_SpinEdit_ConfigProxyPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_BitBtn_ConfigProxyIE.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Edit_ConfigSSHPassword.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_SpinEdit_ConfigSSHLocalPort.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_ComboBox_ConfigSSHUsername.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHPassword.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHPort.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHUsername.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_SpinEdit_ConfigSSHConnWait.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHConnWait.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_BitBtn_ConfigTestSSH.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_SpinEdit_ConfigModPort.Value := opmC_Def_ModPort;
  opm_ComboBox_ConfigModIndex.Items := opmG_ModIndexData_BoxList;
  opm_ComboBox_ConfigModResult.Items := opmG_ModResultData_BoxList;
  opm_ComboBox_ConfigModIndex.ItemIndex := 0;
  opm_ComboBox_ConfigModResult.ItemIndex := 0;
  opm_Edit_ConfigModName.Text := '';
  opm_Edit_ConfigModCmd.Text := '';
  opm_CheckBox_ConfigModRemote.Checked := FALSE;
  opm_CheckBox_ConfigModJustRun.Checked := FALSE;
  opm_CheckBox_ConfigModOnSelection.Checked := FALSE;
  opm_BitBtn_ConfigModDel.Enabled := FALSE;
  opm_PRRefresh_ModuleList (-1);
  opm_ListBox_ConfigMods.ScrollWidth := ROUND (opm_ListBox_ConfigMods.Width * 1.5);
  opm_Label_ConfigDBTable01.Caption := opmC_Def_DBTable_Categories;
  opm_Label_ConfigDBTable02.Caption := opmC_Def_DBTable_Manufacturers;
  opm_Label_ConfigDBTable03.Caption := opmC_Def_DBTable_Languages;
  opm_Label_ConfigDBTable04.Caption := opmC_Def_DBTable_Products;
  opm_Label_ConfigDBTable05.Caption := opmC_Def_DBTable_Specials;
  opm_Label_ConfigDBTable06.Caption := opmC_Def_DBTable_ProductsDescription;
  opm_Label_ConfigDBTable07.Caption := opmC_Def_DBTable_TaxClass;
  opm_Label_ConfigDBTable08.Caption := opmC_Def_DBTable_Currencies;
  opm_Label_ConfigDBTable09.Caption := opmC_Def_DBTable_Configuration;
  opm_Label_ConfigDBTable10.Caption := opmC_Def_DBTable_ProductsToCategories;
  opm_Label_ConfigDBTable11.Caption := opmC_Def_DBTable_CategoriesDescription;
  opm_Label_ConfigDBTable13.Caption := opmC_Def_DBTable_TaxRates;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.PRopm_ControlToVars;
VAR
  LangUIStr : STRING;
BEGIN
  opmG_DBHost := FNopm_CleanHostName (opm_ComboBox_ConfigHost.Text);
  opmG_DBDatabase := TRIM (opm_ComboBox_ConfigDatabase.Text);
  opmG_DBTable_Categories := TRIM (opm_Edit_ConfigDBTable01.Text);
  opmG_DBTable_Manufacturers := TRIM (opm_Edit_ConfigDBTable02.Text);
  opmG_DBTable_Languages := TRIM (opm_Edit_ConfigDBTable03.Text);
  opmG_DBTable_Products := TRIM (opm_Edit_ConfigDBTable04.Text);
  opmG_DBTable_Specials := TRIM (opm_Edit_ConfigDBTable05.Text);
  opmG_DBTable_ProductsDescription := TRIM (opm_Edit_ConfigDBTable06.Text);
  opmG_DBTable_TaxClass := TRIM (opm_Edit_ConfigDBTable07.Text);
  opmG_DBTable_Currencies := TRIM (opm_Edit_ConfigDBTable08.Text);
  opmG_DBTable_Configuration := TRIM (opm_Edit_ConfigDBTable09.Text);
  opmG_DBTable_ProductsToCategories := TRIM (opm_Edit_ConfigDBTable10.Text);
  opmG_DBTable_CategoriesDescription := TRIM (opm_Edit_ConfigDBTable11.Text);
  opmG_DBTable_TaxRates := TRIM (opm_Edit_ConfigDBTable13.Text);
  opmG_DBUsername := TRIM (opm_ComboBox_ConfigUsername.Text);
  opmG_DBPassword := TRIM (opm_Edit_ConfigPassword.Text);
  opmG_WBImgURL := TRIM (opm_ComboBox_ConfigImgURL.Text);
  opmG_WBUploadURL := TRIM (opm_ComboBox_ConfigUploadURL.Text);
  opmG_UploadPassword := TRIM (opm_Edit_ConfigUploadPassword.Text);
  opmG_WBProxyHost := FNopm_CleanHostName (opm_ComboBox_ConfigProxyHost.Text);
  IF (opmG_WBImgURL[LENGTH (opmG_WBImgURL)] <> '/') THEN opmG_WBImgURL := opmG_WBImgURL + '/';
  opmG_DBProtocol := TRIM (opm_ComboBox_ConfigProtocol.Text);
  opmG_DBPort := ABS (opm_SpinEdit_ConfigPort.Value);
  opmG_WBProxyPort := ABS (opm_SpinEdit_ConfigProxyPort.Value);
  opmG_DBConnWait := ABS (ROUND ((opm_SpinEdit_ConfigDBConnWait.Value + 1) / opmC_MiliSecIncrement) * opmC_MiliSecIncrement);
  opmG_SSHConnWait := ABS (ROUND ((opm_SpinEdit_ConfigSSHConnWait.Value + 1) / opmC_MiliSecIncrement) * opmC_MiliSecIncrement);
  opmG_DBConnRetries := ABS (opm_SpinEdit_ConfigDBConnRetries.Value);
  opmG_WBImgX := ABS (opm_SpinEdit_ConfigImgX.Value);
  opmG_WBImgY := ABS (opm_SpinEdit_ConfigImgY.Value);
  opmG_WBImgQ := ABS (opm_SpinEdit_ConfigImgQ.Value);
  IF (opm_CheckBox_ConfigHotTrack.Checked = TRUE) THEN opmG_UIHotTracking := 1 ELSE opmG_UIHotTracking := 0;
  IF (opm_CheckBox_ConfigRemember.Checked = TRUE) THEN opmG_UIRememberDisplay := 1 ELSE opmG_UIRememberDisplay := 0;
  IF (opm_CheckBox_ConfigAutoload.Checked = TRUE) THEN opmG_UIClickLoad := 1 ELSE opmG_UIClickLoad := 0;
  IF (opm_CheckBox_ConfigDragDrop.Checked = TRUE) THEN opmG_UIDragDrop := 1 ELSE opmG_UIDragDrop := 0;
  IF (opm_CheckBox_ConfigToolTips.Checked = TRUE) THEN opmG_UIToolTips := 1 ELSE opmG_UIToolTips := 0;
  IF (opm_CheckBox_ConfigCompress.Checked = TRUE) THEN opmG_DBCompress := 1 ELSE opmG_DBCompress := 0;
  IF (opm_CheckBox_ConfigUseProxy.Checked = TRUE) THEN opmG_UseProxy := 1 ELSE opmG_UseProxy := 0;
  IF (opm_CheckBox_ConfigUseSSH.Checked = TRUE) THEN opmG_UseSSH := 1 ELSE opmG_UseSSH := 0;
  opmG_SSHLocalPort := ABS (opm_SpinEdit_ConfigSSHLocalPort.Value);
  opmG_SSHUsername := TRIM (opm_ComboBox_ConfigSSHUsername.Text);
  opmG_SSHPassword := TRIM (opm_Edit_ConfigSSHPassword.Text);
  IF (opm_CheckBox_ConfigStorePass.Checked = TRUE) THEN opmG_DBStorePass := 1 ELSE opmG_DBStorePass := 0;
  IF (opm_CheckBox_ConfigSilent.Checked = TRUE) THEN opmG_UISilent := 1 ELSE opmG_UISilent := 0;
  IF (opm_CheckBox_ConfigConfirmDels.Checked = TRUE) THEN opmG_UIConfirmDels := 1 ELSE opmG_UIConfirmDels := 0;
  IF (opm_CheckBox_ConfigConfirmDrag.Checked = TRUE) THEN opmG_UIConfirmDrag := 1 ELSE opmG_UIConfirmDrag := 0;
  IF (opm_CheckBox_ConfigConfirmMods.Checked = TRUE) THEN opmG_UIConfirmMods := 1 ELSE opmG_UIConfirmMods := 0;
  IF (opm_CheckBox_ConfigAllowZeroPrice.Checked = TRUE) THEN opmG_UIAllowZeroPrice := 1 ELSE opmG_UIAllowZeroPrice := 0;
  IF (opm_CheckBox_ConfigAllowNegativeQuantity.Checked = TRUE) THEN opmG_UIAllowNegativeQuantity := 1 ELSE opmG_UIAllowNegativeQuantity := 0;
  IF (opm_CheckBox_ConfigAutoDownImg.Checked = TRUE) THEN opmG_UIAutoDownImg := 1 ELSE opmG_UIAutoDownImg := 0;
  opmG_UIFontName := opm_FontDialog_Config.Font.Name;
  opmG_UIFontHeight := opm_FontDialog_Config.Font.Height;
  opmG_UIFontCharset := opm_FontDialog_Config.Font.Charset;
  opmG_PRNFontName := opm_PRNFontDialog_Config.Font.Name;
  opmG_PRNFontSize := ROUND ((opm_PRNFontDialog_Config.Font.Height * -72) / opm_PRNFontDialog_Config.Font.PixelsPerInch);
  opmG_PRNFontCharset := opm_PRNFontDialog_Config.Font.Charset;
  opmG_PRNColSize := ABS (opm_SpinEdit_ConfigPRNColSize.Value);
  IF (opm_CheckBox_ConfigPRNLandscape.Checked = TRUE) THEN opmG_PRNLandscape := 1 ELSE opmG_PRNLandscape := 0;
  IF (opm_CheckBox_ConfigNoCacheImg.Checked = TRUE) THEN opmG_WBNoCacheImg := 1 ELSE opmG_WBNoCacheImg := 0;
  IF (opm_CheckBox_ConfigResizeImg.Checked = TRUE) THEN opmG_WBResizeImg := 1 ELSE opmG_WBResizeImg := 0;
  IF (opm_CheckBox_ConfigPaddingImg.Checked = TRUE) THEN opmG_WBPaddingImg := 1 ELSE opmG_WBPaddingImg := 0;
  IF (opm_CheckBox_ConfigKeepARImg.Checked = TRUE) THEN opmG_WBKeepARImg := 1 ELSE opmG_WBKeepARImg := 0;
  IF (opm_CheckBox_ConfigSmartRename.Checked = TRUE) THEN opmG_WBSmartRename := 1 ELSE opmG_WBSmartRename := 0;
  IF (opm_CheckBox_ConfigConfirmExit.Checked = TRUE) THEN opmG_UIConfirmExit := 1 ELSE opmG_UIConfirmExit := 0;
  IF (opm_CheckBox_ConfigDBDebugLog.Checked = TRUE) THEN opmG_DBDebugLog := 1 ELSE opmG_DBDebugLog := 0;
  IF (opm_CheckBox_ConfigDBDebug.Checked = TRUE) THEN opmG_UIDBDebug := 1 ELSE opmG_UIDBDebug := 0;
  IF (opm_CheckBox_ConfigSSHDebug.Checked = TRUE) THEN opmG_UISSHDebug := 1 ELSE opmG_UISSHDebug := 0;
  IF (opm_CheckBox_ConfigWBDebug.Checked = TRUE) THEN opmG_UIWBDebug := 1 ELSE opmG_UIWBDebug := 0;
  LangUIStr := opm_ComboBox_ConfigUILang.Items[opm_ComboBox_ConfigUILang.ItemIndex];
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    opmG_UIGUILang := COPY (LangUIStr, POS ('(', LangUIStr) + 1,
                            POS (')', LangUIStr) - POS ('(', LangUIStr) - 1)
  ELSE
    opmG_UIGUILang := opmC_Def_GUILang;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigOkClick(Sender: TObject);
begin
  PRopm_ControlToVars;
  PRReg_WriteSetting ('OSCHost', opmG_DBHost, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProtocol', opmG_DBProtocol, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDatabase', opmG_DBDatabase, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable01', opmG_DBTable_Categories, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable02', opmG_DBTable_Manufacturers, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable03', opmG_DBTable_Languages, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable04', opmG_DBTable_Products, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable05', opmG_DBTable_Specials, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable06', opmG_DBTable_ProductsDescription, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable07', opmG_DBTable_TaxClass, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable08', opmG_DBTable_Currencies, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable09', opmG_DBTable_Configuration, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable10', opmG_DBTable_ProductsToCategories, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable11', opmG_DBTable_CategoriesDescription, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable13', opmG_DBTable_TaxRates, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUsername', opmG_DBUsername, opmC_RegistryKey, opmC_RKConfig);
  IF (opmG_DBStorePass > 0) THEN
    PRReg_WriteSetting ('OSCPassword', opmG_DBPassword, opmC_RegistryKey, opmC_RKConfig)
  ELSE
    PRReg_WriteSetting ('OSCPassword', '', opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgURL', opmG_WBImgURL, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUploadURL', opmG_WBUploadURL, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUploadPassword', opmG_UploadPassword, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProxyHost', opmG_WBProxyHost, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPort', IntToStr (opmG_DBPort), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProxyPort', IntToStr (opmG_WBProxyPort), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDBConnWait', IntToStr (opmG_DBConnWait), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSSHConnWait', IntToStr (opmG_SSHConnWait), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDBConnRetries', IntToStr (opmG_DBConnRetries), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgX', IntToStr (opmG_WBImgX), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgY', IntToStr (opmG_WBImgY), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgQ', IntToStr (opmG_WBImgQ), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPaddingColor', IntToStr (opmG_WBPaddingColor), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCHotTracking', IntToStr (opmG_UIHotTracking), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAutoLoad', IntToStr (opmG_UIClickLoad), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDragDrop', IntToStr (opmG_UIDragDrop), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCToolTips', IntToStr (opmG_UIToolTips), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCCompress', IntToStr (opmG_DBCompress), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUseProxy', IntToStr (opmG_UseProxy), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUseSSH', IntToStr (opmG_UseSSH), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSSHUsername', opmG_SSHUsername, opmC_RegistryKey, opmC_RKConfig);
  IF (opmG_DBStorePass > 0) THEN
    PRReg_WriteSetting ('OSCSSHPassword', opmG_SSHPassword, opmC_RegistryKey, opmC_RKConfig)
  ELSE
    PRReg_WriteSetting ('OSCSSHPassword', '', opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSSHLocalPort', IntToStr (opmG_SSHLocalPort), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCStorePass', IntToStr (opmG_DBStorePass), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSilent', IntToStr (opmG_UISilent), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmDels', IntToStr (opmG_UIConfirmDels), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmDrag', IntToStr (opmG_UIConfirmDrag), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmMods', IntToStr (opmG_UIConfirmMods), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAllowZeroPrice', IntToStr (opmG_UIAllowZeroPrice), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAllowNegativeQuantity', IntToStr (opmG_UIAllowNegativeQuantity), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAutoDownImg', IntToStr (opmG_UIAutoDownImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('UIFontName', opmG_UIFontName, opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('UIFontHeight', INTTOSTR (opmG_UIFontHeight), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('UIFontCharset', INTTOSTR (opmG_UIFontCharset), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNFontName', opmG_PRNFontName, opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNFontSize', INTTOSTR (opmG_PRNFontSize), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNFontCharset', INTTOSTR (opmG_PRNFontCharset), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNColSize', IntToStr (opmG_PRNColSize), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNLandscape', IntToStr (opmG_PRNLandscape), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastAvailDate', INTTOSTR (opmG_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastManufacturer', INTTOSTR (opmG_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastTaxClass', INTTOSTR (opmG_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastImageDir', opmG_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('OSCNoCacheImg', IntToStr (opmG_WBNoCacheImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCResizeImg', IntToStr (opmG_WBResizeImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPaddingImg', IntToStr (opmG_WBPaddingImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCKeepARImg', IntToStr (opmG_WBKeepARImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSmartRename', IntToStr (opmG_WBSmartRename), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmExit', IntToStr (opmG_UIConfirmExit), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDBDebugLog', IntToStr (opmG_DBDebugLog), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDBDebug', IntToStr (opmG_UIDBDebug), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSSHDebug', IntToStr (opmG_UISSHDebug), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCWBDebug', IntToStr (opmG_UIWBDebug), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCRememberPosition', IntToStr (opmG_UIRememberDisplay), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WritePastList ('Host', opmC_RegistryKey, opmC_RKServers, opmG_DBHost, opmG_PastHost_BoxList, opmC_MaxPast_Servers);
  PRReg_WritePastList ('Database', opmC_RegistryKey, opmC_RKServers, opmG_DBDatabase, opmG_PastDatabase_BoxList, opmC_MaxPast_Databases);
  PRReg_WritePastList ('Username', opmC_RegistryKey, opmC_RKServers, opmG_DBUsername, opmG_PastUsername_BoxList, opmC_MaxPast_Usernames);
  PRReg_WritePastList ('SSHUsername', opmC_RegistryKey, opmC_RKServers, opmG_SSHUsername, opmG_PastSSHUsername_BoxList, opmC_MaxPast_SSHUsernames);
  PRReg_WritePastList ('ImgURL', opmC_RegistryKey, opmC_RKServers, opmG_WBImgURL, opmG_PastImgURL_BoxList, opmC_MaxPast_ImgURL);
  PRReg_WritePastList ('UploadURL', opmC_RegistryKey, opmC_RKServers, opmG_WBUploadURL, opmG_PastUploadURL_BoxList, opmC_MaxPast_UploadURL);
  PRReg_WritePastList ('Proxy', opmC_RegistryKey, opmC_RKServers, opmG_WBProxyHost, opmG_PastProxy_BoxList, opmC_MaxPast_Proxy);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.FormCreate(Sender: TObject);
begin
  opm_SpinEdit_ConfigPort.MinValue := opmC_Min_Port;
  opm_SpinEdit_ConfigPort.MaxValue := opmC_Max_Port;
  opm_SpinEdit_ConfigProxyPort.MinValue := opmC_Min_ProxyPort;
  opm_SpinEdit_ConfigProxyPort.MaxValue := opmC_Max_ProxyPort;
  opm_SpinEdit_ConfigDBConnWait.MinValue := opmC_Min_DBConnWait;
  opm_SpinEdit_ConfigDBConnWait.MaxValue := opmC_Max_DBConnWait;
  opm_SpinEdit_ConfigDBConnWait.Increment := opmC_MiliSecIncrement;
  opm_SpinEdit_ConfigSSHConnWait.MinValue := opmC_Min_SSHConnWait;
  opm_SpinEdit_ConfigSSHConnWait.MaxValue := opmC_Max_SSHConnWait;
  opm_SpinEdit_ConfigSSHConnWait.Increment := opmC_MiliSecIncrement;
  opm_SpinEdit_ConfigDBConnRetries.MinValue := opmC_Min_DBConnRetries;
  opm_SpinEdit_ConfigDBConnRetries.MaxValue := opmC_Max_DBConnRetries;
  opm_SpinEdit_ConfigImgX.MinValue := opmC_Min_ImgX;
  opm_SpinEdit_ConfigImgX.MaxValue := opmC_Max_ImgX;
  opm_SpinEdit_ConfigImgY.MinValue := opmC_Min_ImgY;
  opm_SpinEdit_ConfigImgY.MaxValue := opmC_Max_ImgY;
  opm_SpinEdit_ConfigImgQ.MinValue := opmC_Min_ImgQ;
  opm_SpinEdit_ConfigImgQ.MaxValue := opmC_Max_ImgQ;
  opm_SpinEdit_ConfigModPort.MinValue := opmC_Min_ModPort;
  opm_SpinEdit_ConfigModPort.MaxValue := opmC_Max_ModPort;
  opm_ComboBox_ConfigProtocol.Items.Text := opmC_SQLBackends;
  opm_Edit_ConfigPassword.PasswordChar := opmC_PasswordChar;
  opm_Edit_ConfigSSHPassword.PasswordChar := opmC_PasswordChar;
  opm_Edit_ConfigUploadPassword.PasswordChar := opmC_PasswordChar;
  opm_ComboBox_ConfigModIndex.Sorted := FALSE;
  opm_ComboBox_ConfigModResult.Sorted := FALSE;
  opm_Edit_ConfigModName.MaxLength := opmC_Max_ModNameWidth;
  opm_Edit_ConfigModCmd.MaxLength := opmC_Max_ModCMDWidth;
  opm_FontDialog_Config.MinFontSize := opmC_Min_FontHeight;
  opm_FontDialog_Config.MaxFontSize := opmC_Max_FontHeight;
  opm_PRNFontDialog_Config.MinFontSize := opmC_Min_PRNFontSize;
  opm_PRNFontDialog_Config.MaxFontSize := opmC_Max_PRNFontSize;
  opm_SpinEdit_ConfigPRNColSize.MinValue := opmC_Min_PRNColSize;
  opm_SpinEdit_ConfigPRNColSize.MaxValue := opmC_Max_PRNColSize;
  IF (opmG_UIHotTracking > 0) THEN
    opm_PageControl_Config.HotTrack := TRUE
  ELSE
    opm_PageControl_Config.HotTrack := FALSE;
  TranslateComponent (self);
  PRballoon_SetFormBalloons (self, opmG_UIToolTips);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigResetClick(Sender: TObject);
begin
  IF (opmC_Def_HotTracking > 0) THEN opm_CheckBox_ConfigHotTrack.Checked := TRUE ELSE opm_CheckBox_ConfigHotTrack.Checked := FALSE;
  IF (opmC_Def_RememberDisplay > 0) THEN opm_CheckBox_ConfigRemember.Checked := TRUE ELSE opm_CheckBox_ConfigRemember.Checked := FALSE;
  IF (opmC_Def_AutoLoad > 0) THEN opm_CheckBox_ConfigAutoload.Checked := TRUE ELSE opm_CheckBox_ConfigAutoload.Checked := FALSE;
  IF (opmC_Def_DragDrop > 0) THEN opm_CheckBox_ConfigDragDrop.Checked := TRUE ELSE opm_CheckBox_ConfigDragDrop.Checked := FALSE;
  IF (opmC_Def_Tooltips > 0) THEN opm_CheckBox_ConfigTooltips.Checked := TRUE ELSE opm_CheckBox_ConfigTooltips.Checked := FALSE;
  IF (opmC_Def_ConfirmDels > 0) THEN opm_CheckBox_ConfigConfirmDels.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmDels.Checked := FALSE;
  IF (opmC_Def_ConfirmDrag > 0) THEN opm_CheckBox_ConfigConfirmDrag.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmDrag.Checked := FALSE;
  IF (opmC_Def_ConfirmMods > 0) THEN opm_CheckBox_ConfigConfirmMods.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmMods.Checked := FALSE;
  IF (opmC_Def_AllowZeroPrice > 0) THEN opm_CheckBox_ConfigAllowZeroPrice.Checked := TRUE ELSE opm_CheckBox_ConfigAllowZeroPrice.Checked := FALSE;
  IF (opmC_Def_AllowNegativeQuantity > 0) THEN opm_CheckBox_ConfigAllowNegativeQuantity.Checked := TRUE ELSE opm_CheckBox_ConfigAllowNegativeQuantity.Checked := FALSE;
  IF (opmC_Def_AutoDownImg > 0) THEN opm_CheckBox_ConfigAutoDownImg.Checked := TRUE ELSE opm_CheckBox_ConfigAutoDownImg.Checked := FALSE;
  IF (opmC_Def_NoCacheImg > 0) THEN opm_CheckBox_ConfigNoCacheImg.Checked := TRUE ELSE opm_CheckBox_ConfigNoCacheImg.Checked := FALSE;
  IF (opmC_Def_ConfirmExit > 0) THEN opm_CheckBox_ConfigConfirmExit.Checked := TRUE ELSE opm_CheckBox_ConfigConfirmExit.Checked := FALSE;
  IF (opmC_Def_DBDebugLog > 0) THEN opm_CheckBox_ConfigDBDebugLog.Checked := TRUE ELSE opm_CheckBox_ConfigDBDebugLog.Checked := FALSE;
  IF (opmC_Def_DBDebug > 0) THEN opm_CheckBox_ConfigDBDebug.Checked := TRUE ELSE opm_CheckBox_ConfigDBDebug.Checked := FALSE;
  IF (opmC_Def_SSHDebug > 0) THEN opm_CheckBox_ConfigSSHDebug.Checked := TRUE ELSE opm_CheckBox_ConfigSSHDebug.Checked := FALSE;
  IF (opmC_Def_WBDebug > 0) THEN opm_CheckBox_ConfigWBDebug.Checked := TRUE ELSE opm_CheckBox_ConfigWBDebug.Checked := FALSE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigResizeImgClick (Sender: TObject);
begin
  opm_Label_ConfigImgResize.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigPaddingImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigKeepARImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgX.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgY.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Panel_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_BitBtn_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgQ.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigImgJPEGQuality.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigJPEGQCategory.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigSaveINIClick(Sender: TObject);
begin
  opm_SaveDialog_ConfigINI.DefaultExt := opmC_Def_SaveINIExt;
  opm_SaveDialog_ConfigINI.FileName := opmC_Def_SaveINIFilename;
  opm_SaveDialog_ConfigINI.Filter := _('Configuration files') + ' (' + opmC_Def_SaveINIFilter + ')|' + opmC_Def_SaveINIFilter + '|' + _('All files (*.*)');
  opm_SaveDialog_ConfigINI.Title := _('Saving configuration file...');
  opm_SaveDialog_ConfigINI.InitialDir := ExtractFilePath (Application.Exename);
  IF (opm_SaveDialog_ConfigINI.Execute = TRUE) THEN
    BEGIN
      PRopm_ControlToVars;
      PRINI_WriteSetting ('OSCHost', opmG_DBHost, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProtocol', opmG_DBProtocol, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDatabase', opmG_DBDatabase, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable01', opmG_DBTable_Categories, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable02', opmG_DBTable_Manufacturers, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable03', opmG_DBTable_Languages, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable04', opmG_DBTable_Products, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable05', opmG_DBTable_Specials, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable06', opmG_DBTable_ProductsDescription, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable07', opmG_DBTable_TaxClass, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable08', opmG_DBTable_Currencies, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable09', opmG_DBTable_Configuration, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable10', opmG_DBTable_ProductsToCategories, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable11', opmG_DBTable_CategoriesDescription, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable13', opmG_DBTable_TaxRates, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUsername', opmG_DBUsername, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      IF (opmG_DBStorePass > 0) THEN
        PRINI_WriteSetting ('OSCPassword', opmG_DBPassword, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig)
      ELSE
        PRINI_WriteSetting ('OSCPassword', '', opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgURL', opmG_WBImgURL, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUploadURL', opmG_WBUploadURL, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUploadPassword', opmG_UploadPassword, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProxyHost', opmG_WBProxyHost, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPort', IntToStr (opmG_DBPort), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProxyPort', IntToStr (opmG_WBProxyPort), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDBConnWait', IntToStr (opmG_DBConnWait), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSSHConnWait', IntToStr (opmG_SSHConnWait), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDBConnRetries', IntToStr (opmG_DBConnRetries), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgX', IntToStr (opmG_WBImgX), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgY', IntToStr (opmG_WBImgY), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgQ', IntToStr (opmG_WBImgQ), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPaddingColor', IntToStr (opmG_WBPaddingColor), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCHotTracking', IntToStr (opmG_UIHotTracking), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAutoLoad', IntToStr (opmG_UIClickLoad), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDragDrop', IntToStr (opmG_UIDragDrop), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCToolTips', IntToStr (opmG_UIToolTips), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCCompress', IntToStr (opmG_DBCompress), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUseProxy', IntToStr (opmG_UseProxy), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUseSSH', IntToStr (opmG_UseSSH), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSSHUsername', opmG_SSHUsername, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      IF (opmG_DBStorePass > 0) THEN
        PRINI_WriteSetting ('OSCSSHPassword', opmG_SSHPassword, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig)
      ELSE
        PRINI_WriteSetting ('OSCSSHPassword', '', opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSSHLocalPort', IntToStr (opmG_SSHLocalPort), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCStorePass', IntToStr (opmG_DBStorePass), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSilent', IntToStr (opmG_UISilent), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmDels', IntToStr (opmG_UIConfirmDels), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmDrag', IntToStr (opmG_UIConfirmDrag), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmMods', IntToStr (opmG_UIConfirmMods), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAllowZeroPrice', IntToStr (opmG_UIAllowZeroPrice), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAllowNegativeQuantity', IntToStr (opmG_UIAllowNegativeQuantity), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAutoDownImg', IntToStr (opmG_UIAutoDownImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('UIFontName', opmG_UIFontName, opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('UIFontHeight', INTTOSTR (opmG_UIFontHeight), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('UIFontCharset', INTTOSTR (opmG_UIFontCharset), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNFontName', opmG_PRNFontName, opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNFontSize', INTTOSTR (opmG_PRNFontSize), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNFontCharset', INTTOSTR (opmG_PRNFontCharset), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNColSize', IntToStr (opmG_PRNLandscape), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNLandscape', IntToStr (opmG_PRNLandscape), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastAvailDate', INTTOSTR (opmG_Past_PAvailDate), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastManufacturer', INTTOSTR (opmG_Past_PManufacturer), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastTaxClass', INTTOSTR (opmG_Past_PTaxClass), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastImageDir', opmG_Past_PImageDir, opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('OSCNoCacheImg', IntToStr (opmG_WBNoCacheImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCResizeImg', IntToStr (opmG_WBResizeImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPaddingImg', IntToStr (opmG_WBPaddingImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCKeepARImg', IntToStr (opmG_WBKeepARImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSmartRename', IntToStr (opmG_WBSmartRename), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmExit', IntToStr (opmG_UIConfirmExit), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDBDebugLog', IntToStr (opmG_DBDebugLog), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDBDebug', IntToStr (opmG_UIDBDebug), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSSHDebug', IntToStr (opmG_UISSHDebug), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCWBDebug', IntToStr (opmG_UIWBDebug), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCRememberPosition', IntToStr (opmG_UIRememberDisplay), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigLoadINIClick(Sender: TObject);
begin
  opm_OpenDialog_ConfigINI.DefaultExt := opmC_Def_LoadINIExt;
  opm_OpenDialog_ConfigINI.FileName := '';
  opm_OpenDialog_ConfigINI.Filter := _('Configuration files') + ' (' + opmC_Def_LoadINIFilter + ')|' + opmC_Def_LoadINIFilter + '|' + _('All files (*.*)');
  opm_OpenDialog_ConfigINI.Title := _('Loading configuration file...');
  opm_OpenDialog_ConfigINI.InitialDir := ExtractFilePath (Application.Exename);
  IF (opm_OpenDialog_ConfigINI.Execute = TRUE) THEN
    BEGIN
      opmG_DBHost := FNopm_CleanHostName (FNINI_ReadSetting ('OSCHost', opmC_Def_Host, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBPort := FNopm_StrToInt (FNINI_ReadSetting ('OSCPort', INTTOSTR (opmC_Def_Port), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBProtocol := FNINI_ReadSetting ('OSCProtocol', opmC_Def_Protocol, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBDatabase := FNINI_ReadSetting ('OSCDatabase', opmC_Def_Database, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Categories := FNINI_ReadSetting ('OSCTable01', opmC_Def_DBTable_Categories, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Manufacturers := FNINI_ReadSetting ('OSCTable02', opmC_Def_DBTable_Manufacturers, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Languages := FNINI_ReadSetting ('OSCTable03', opmC_Def_DBTable_Languages, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Products := FNINI_ReadSetting ('OSCTable04', opmC_Def_DBTable_Products, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Specials := FNINI_ReadSetting ('OSCTable05', opmC_Def_DBTable_Specials, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_ProductsDescription := FNINI_ReadSetting ('OSCTable06', opmC_Def_DBTable_ProductsDescription, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_TaxClass := FNINI_ReadSetting ('OSCTable07', opmC_Def_DBTable_TaxClass, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Currencies := FNINI_ReadSetting ('OSCTable08', opmC_Def_DBTable_Currencies, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_Configuration := FNINI_ReadSetting ('OSCTable09', opmC_Def_DBTable_Configuration, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_ProductsToCategories := FNINI_ReadSetting ('OSCTable10', opmC_Def_DBTable_ProductsToCategories, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_CategoriesDescription := FNINI_ReadSetting ('OSCTable11', opmC_Def_DBTable_CategoriesDescription, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBTable_TaxRates := FNINI_ReadSetting ('OSCTable13', opmC_Def_DBTable_TaxRates, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBUsername := FNINI_ReadSetting ('OSCUsername', opmC_Def_Username, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBPassword := FNINI_ReadSetting ('OSCPassword', opmC_Def_Password, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBImgURL := FNINI_ReadSetting ('OSCImgURL', opmC_Def_ImgURL, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBUploadURL := FNINI_ReadSetting ('OSCUploadURL', opmC_Def_UploadURL, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_UploadPassword := FNINI_ReadSetting ('OSCUploadPassword', opmC_Def_UploadPassword, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBProxyHost := FNopm_CleanHostName (FNINI_ReadSetting ('OSCProxyHost', opmC_Def_ProxyHost, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBProxyPort := FNopm_StrToInt (FNINI_ReadSetting ('OSCProxyPort', INTTOSTR (opmC_Def_ProxyPort), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBConnWait := FNopm_StrToInt (FNINI_ReadSetting ('OSCDBConnWait', INTTOSTR (opmC_Def_DBConnWait), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_SSHConnWait := FNopm_StrToInt (FNINI_ReadSetting ('OSCSSHConnWait', INTTOSTR (opmC_Def_SSHConnWait), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBConnRetries := FNopm_StrToInt (FNINI_ReadSetting ('OSCDBConnRetries', INTTOSTR (opmC_Def_DBConnRetries), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgX := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgX', INTTOSTR (opmC_Def_ImgX), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgY := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgY', INTTOSTR (opmC_Def_ImgY), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgQ := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgQ', INTTOSTR (opmC_Def_ImgQ), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBPaddingColor := FNopm_StrToInt (FNINI_ReadSetting ('OSCPaddingColor', INTTOSTR (opmC_Def_PaddingColor), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      IF (opmG_WBImgURL[LENGTH (opmG_WBImgURL)] <> '/') THEN opmG_WBImgURL := opmG_WBImgURL + '/';
      opmG_UIHotTracking := FNopm_StrToInt (FNINI_ReadSetting ('OSCHotTracking', INTTOSTR (opmC_Def_HotTracking), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIClickLoad := FNopm_StrToInt (FNINI_ReadSetting ('OSCAutoLoad', INTTOSTR (opmC_Def_AutoLoad), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIDragDrop := FNopm_StrToInt (FNINI_ReadSetting ('OSCDragDrop', INTTOSTR (opmC_Def_DragDrop), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIToolTips := FNopm_StrToInt (FNINI_ReadSetting ('OSCToolTips', INTTOSTR (opmC_Def_ToolTips), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBCompress := FNopm_StrToInt (FNINI_ReadSetting ('OSCCompress', INTTOSTR (opmC_Def_Compress), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UseProxy := FNopm_StrToInt (FNINI_ReadSetting ('OSCUseProxy', INTTOSTR (opmC_Def_UseProxy), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UseSSH := FNopm_StrToInt (FNINI_ReadSetting ('OSCUseSSH', INTTOSTR (opmC_Def_UseSSH), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_SSHUsername := FNINI_ReadSetting ('OSCSSHUsername', opmC_Def_SSHUsername, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_SSHPassword := FNINI_ReadSetting ('OSCSSHPassword', opmC_Def_SSHPassword, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_SSHLocalPort := FNopm_StrToInt (FNINI_ReadSetting ('OSCSSHLocalPort', INTTOSTR (opmC_Def_SSHLocalPort), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBStorePass := FNopm_StrToInt (FNINI_ReadSetting ('OSCStorePass', INTTOSTR (opmC_Def_StorePass), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UISilent := FNopm_StrToInt (FNINI_ReadSetting ('OSCSilent', INTTOSTR (opmC_Def_Silent), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmDels := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmDels', INTTOSTR (opmC_Def_ConfirmDels), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmDrag := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmDrag', INTTOSTR (opmC_Def_ConfirmDrag), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmMods := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmMods', INTTOSTR (opmC_Def_ConfirmMods), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAllowZeroPrice := FNopm_StrToInt (FNINI_ReadSetting ('OSCAllowZeroPrice', INTTOSTR (opmC_Def_AllowZeroPrice), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAllowNegativeQuantity := FNopm_StrToInt (FNINI_ReadSetting ('OSCAllowNegativeQuantity', INTTOSTR (opmC_Def_AllowNegativeQuantity), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAutoDownImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCAutoDownImg', INTTOSTR (opmC_Def_AutoDownImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIFontName := FNReg_ReadSetting ('UIFontName', opmC_DefaultFont, opmC_RegistryKey, opmC_RKVisual);
      opmG_UIFontHeight := FNopm_StrToInt (FNReg_ReadSetting ('UIFontHeight', INTTOSTR (opmC_DefaultFontHeight), opmC_RegistryKey, opmC_RKVisual));
      opmG_UIFontCharset := FNopm_StrToInt (FNReg_ReadSetting ('UIFontCharset', INTTOSTR (opmC_DefaultFontCharset), opmC_RegistryKey, opmC_RKVisual));
      opmG_PRNFontName := FNReg_ReadSetting ('PRNFontName', opmC_Def_PRNFont, opmC_RegistryKey, opmC_RKVisual);
      opmG_PRNFontSize := FNopm_StrToInt (FNReg_ReadSetting ('PRNFontSize', INTTOSTR (opmC_Def_PRNFontSize), opmC_RegistryKey, opmC_RKVisual));
      opmG_PRNFontCharset := FNopm_StrToInt (FNReg_ReadSetting ('PRNFontCharset', INTTOSTR (opmC_Def_PRNFontCharset), opmC_RegistryKey, opmC_RKVisual));
      opmG_PRNColSize := FNopm_StrToInt (FNReg_ReadSetting ('PRNColSize', INTTOSTR (opmC_Def_PRNColSize), opmC_RegistryKey, opmC_RKVisual));
      opmG_PRNLandscape := FNopm_StrToInt (FNReg_ReadSetting ('PRNLandscape', INTTOSTR (opmC_Def_PRNLandscape), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PAvailDate := FNopm_StrToInt (FNReg_ReadSetting ('PastAvailDate', INTTOSTR (opmG_Def_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PManufacturer := FNopm_StrToInt (FNReg_ReadSetting ('PastManufacturer', INTTOSTR (opmG_Def_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PTaxClass := FNopm_StrToInt (FNReg_ReadSetting ('PastTaxClass', INTTOSTR (opmG_Def_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PImageDir := FNReg_ReadSetting ('PastImageDir', opmG_Def_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
      opmG_WBNoCacheImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCNoCacheImg', INTTOSTR (opmC_Def_NoCacheImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBResizeImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCResizeImg', INTTOSTR (opmC_Def_ResizeImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBPaddingImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCPaddingImg', INTTOSTR (opmC_Def_PaddingImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBKeepARImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCKeepARImg', INTTOSTR (opmC_Def_KeepARImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBSmartRename := FNopm_StrToInt (FNINI_ReadSetting ('OSCSmartRename', INTTOSTR (opmC_Def_SmartRename), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmExit := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmExit', INTTOSTR (opmC_Def_ConfirmExit), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBDebugLog := FNopm_StrToInt (FNINI_ReadSetting ('OSCDBDebugLog', INTTOSTR (opmC_Def_DBDebugLog), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIDBDebug := FNopm_StrToInt (FNINI_ReadSetting ('OSCDBDebug', INTTOSTR (opmC_Def_DBDebug), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UISSHDebug := FNopm_StrToInt (FNINI_ReadSetting ('OSCSSHDebug', INTTOSTR (opmC_Def_SSHDebug), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIWBDebug := FNopm_StrToInt (FNINI_ReadSetting ('OSCWBDebug', INTTOSTR (opmC_Def_WBDebug), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIGUILang := FNINI_ReadSetting ('OSCGUILang', opmC_Def_GUILang, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      IF (FNopm_CheckLanguage (opmG_UIGUILang) = FALSE) THEN opmG_UIGUILang := opmC_Def_GUILang;
      opmG_UIRememberDisplay := FNopm_StrToInt (FNINI_ReadSetting ('OSCRememberPosition', INTTOSTR (opmC_Def_RememberDisplay), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      PRopm_VarsToControls;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_SpinEdit_ConfigImgQChange (Sender: TObject);
begin
  opm_Label_ConfigJPEGQCategory.Caption := FNopm_QualityExplain (opm_SpinEdit_ConfigImgQ.Value);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModSaveClick(Sender: TObject);
begin
  opm_CurrentModuleRecord.Name := FNopm_CleanUploadName (TRIM (opm_Edit_ConfigModName.Text));
  opm_CurrentModuleRecord.CommandFile := ExtractFileName (TRIM (opm_Edit_ConfigModCmd.Text));
  opm_CurrentModuleRecord.CommandPara := TRIM (opm_Edit_ConfigModPara.Text);
  opm_CurrentModuleRecord.Port := opm_SpinEdit_ConfigModPort.Value;
  IF (opm_CheckBox_ConfigModRemote.Checked = TRUE) THEN opm_CurrentModuleRecord.Remote := 1 ELSE opm_CurrentModuleRecord.Remote := 0;
  IF (opm_CheckBox_ConfigModJustRun.Checked = TRUE) THEN opm_CurrentModuleRecord.JustRun := 1 ELSE opm_CurrentModuleRecord.JustRun := 0;
  IF (opm_CheckBox_ConfigModOnSelection.Checked = TRUE) THEN opm_CurrentModuleRecord.OnSelection := 1 ELSE opm_CurrentModuleRecord.OnSelection := 0;
  opm_CurrentModuleRecord.IndexData := TRIM (opm_ComboBox_ConfigModIndex.Text);
  opm_CurrentModuleRecord.ResultData := TRIM (opm_ComboBox_ConfigModResult.Text);
  IF (opm_FNSave_ModuleData (opm_CurrentModuleRecord) = FALSE) THEN
    FNopm_Message (_('Missing or wrong data.'), mtError, [mbOK], opmG_UISilent);
  opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
end;

procedure Topm_Form_Config.opm_BitBtn_ConfigModLoadClick(Sender: TObject);
begin
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModCleanClick(Sender: TObject);
begin
  opm_Edit_ConfigModName.Text := '';
  opm_Edit_ConfigModCmd.Text := '';
  opm_Edit_ConfigModPara.Text := '';
  opm_SpinEdit_ConfigModPort.Value := opmC_Def_ModPort;
  opm_CheckBox_ConfigModRemote.Checked := FALSE;
  opm_CheckBox_ConfigModJustRun.Checked := FALSE;
  opm_CheckBox_ConfigModOnSelection.Checked := FALSE;
  opm_ComboBox_ConfigModIndex.ItemIndex := 0;
  opm_ComboBox_ConfigModResult.ItemIndex := 0;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModDelClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    BEGIN
      opm_PRDelete_ModuleData (opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + '.' + opmC_Def_ModulesExt);
      opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.opm_PRRefresh_ModuleList (LastIndex : INTEGER);
VAR
  ModCounter : LONGINT;
BEGIN
  opm_PRLoad_ModuleList;
  opm_ListBox_ConfigMods.Items.Clear;
  FOR ModCounter := 0 TO (opm_TotalModules - 1) DO
    opm_ListBox_ConfigMods.Items.Add (opmG_ModuleList[ModCounter].Name);
  IF ((LastIndex + 1) < opm_TotalModules) THEN
    opm_ListBox_ConfigMods.ItemIndex := LastIndex
  ELSE opm_ListBox_ConfigMods.ItemIndex := (opm_TotalModules - 1);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_ListBox_ConfigModsClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    BEGIN
      opm_BitBtn_ConfigModDel.Enabled := TRUE;
      opm_CurrentModuleRecord := opm_FNLoad_ModuleData (opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + '.' + opmC_Def_ModulesExt);
      opm_Edit_ConfigModName.Text := opm_CurrentModuleRecord.Name;
      opm_Edit_ConfigModCmd.Text := opm_CurrentModuleRecord.CommandFile;
      opm_Edit_ConfigModPara.Text := opm_CurrentModuleRecord.CommandPara;
      opm_SpinEdit_ConfigModPort.Value := opm_CurrentModuleRecord.Port;
      opm_CheckBox_ConfigModRemote.Checked := (opm_CurrentModuleRecord.Remote > 0);
      opm_CheckBox_ConfigModJustRun.Checked := (opm_CurrentModuleRecord.JustRun > 0);
      opm_CheckBox_ConfigModOnSelection.Checked := (opm_CurrentModuleRecord.OnSelection > 0);
      opm_ComboBox_ConfigModIndex.ItemIndex := opm_FNGetListIndexByString (opm_CurrentModuleRecord.IndexData, opmG_ModIndexData_BoxList);
      opm_ComboBox_ConfigModResult.ItemIndex := opm_FNGetListIndexByString (opm_CurrentModuleRecord.ResultData, opmG_ModResultData_BoxList);
    END
  ELSE opm_BitBtn_ConfigModDel.Enabled := FALSE;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModFileClick(Sender: TObject);
begin
  opm_OpenDialog_ConfigMod.DefaultExt := opmC_Def_LoadModExt;
  opm_OpenDialog_ConfigMod.FileName := '';
  opm_OpenDialog_ConfigMod.Filter := _('Executable files') + ' (' + opmC_Def_LoadModFilter + ')|' + opmC_Def_LoadModFilter + '|' + _('All files (*.*)');
  opm_OpenDialog_ConfigMod.Title := _('Choosing module file...');
  opm_OpenDialog_ConfigMod.InitialDir := opm_ModuleDirectory;
  IF (opm_OpenDialog_ConfigMod.Execute = TRUE) THEN
    BEGIN
      opm_Edit_ConfigModCmd.Text := TRIM (ExtractFileName (opm_OpenDialog_ConfigMod.FileName));
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigColSelClick(Sender: TObject);
begin
  opm_Form_ColorSel.opmG_ColorChoosed := FNopm_DecColorToColor (opmG_WBPaddingColor);
  IF (opm_Form_ColorSel.ShowModal = mrOk) THEN
    BEGIN
      opmG_WBPaddingColor := opm_Form_ColorSel.opmG_ColorChoosedDec;
      opm_Panel_ConfigColSel.Color := opm_Form_ColorSel.opmG_ColorChoosed;
      opm_Panel_ConfigColSel.Caption := FNopm_ColorToRGB (opm_Panel_ConfigColSel.Color);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigUseSSHClick(Sender: TObject);
begin
  opm_Edit_ConfigSSHPassword.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_SpinEdit_ConfigSSHLocalPort.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_ComboBox_ConfigSSHUsername.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHPassword.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHPort.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHUsername.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_SpinEdit_ConfigSSHConnWait.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_Label_ConfigSSHConnWait.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
  opm_BitBtn_ConfigTestSSH.Enabled := opm_CheckBox_ConfigUseSSH.Checked;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigProxyIEClick(Sender: TObject);
VAR
  PHost : STRING;
  PPort : LONGINT;
begin
  PRopm_GetIEProxyData (PHost, PPort);
  IF ((PHost <> '') AND (PPort > 0)) THEN
    BEGIN
      opm_ComboBox_ConfigProxyHost.Text := PHost;
      opm_SpinEdit_ConfigProxyPort.Value := PPort;
    END
  ELSE
    FNopm_Message (_('Cannot find the proxy settings automatically.'), mtWarning, [mbOK], opmG_UISilent);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigTestSSHClick(Sender: TObject);
begin
  IF (FNopm_Message (_('This test will close any SSH tunnel currently active. Are you sure you want to proceed with the test?'), mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes) THEN
    BEGIN
      PRopm_StopExternalAppByName (opmC_Def_SSHExe);
      IF (FNopm_OpenSSHTunnel (opmC_Def_SSHLocalHost, TRIM (opm_ComboBox_ConfigHost.Text), ABS (opm_SpinEdit_ConfigSSHLocalPort.Value),
                               ABS (opm_SpinEdit_ConfigPort.Value), TRIM (opm_ComboBox_ConfigSSHUsername.Text),
                               TRIM (opm_Edit_ConfigSSHPassword.Text), 1) = FALSE) THEN
        BEGIN
          FNopm_Message (_('Cannot launch SSH tunnel auxiliar application!'), mtWarning	, [mbOk], opmG_UISilent);
        END;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigFontClick (Sender: TObject);
begin
  IF (opm_FontDialog_Config.Execute = TRUE) THEN
    BEGIN
      opm_Label_ConfigFontDetails.Caption := opm_FontDialog_Config.Font.Name + ', ' +
                                             INTTOSTR (ROUND ((opm_FontDialog_Config.Font.Height * -72) / opm_FontDialog_Config.Font.PixelsPerInch)) + ', ' +
                                             opmG_CharsetList [opm_FontDialog_Config.Font.Charset];
      FNopm_Message (_('The font will change until you restart the application.'), mtInformation, [mbOk], opmG_UISilent);
    END
  ELSE
    BEGIN
      opm_FontDialog_Config.Font.Name := opmG_UIFontName;
      opm_FontDialog_Config.Font.Height := opmG_UIFontHeight;
      opm_FontDialog_Config.Font.Charset := opmG_UIFontCharset;
      opm_FontDialog_Config.Font.Style := opmC_DefaultFontStyle;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigUseProxyClick (Sender: TObject);
begin
  opm_ComboBox_ConfigProxyHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_SpinEdit_ConfigProxyPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_BitBtn_ConfigProxyIE.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigDBResetClick(Sender: TObject);
begin
  opm_Edit_ConfigDBTable01.Text := opmC_Def_DBTable_Categories;
  opm_Edit_ConfigDBTable02.Text := opmC_Def_DBTable_Manufacturers;
  opm_Edit_ConfigDBTable03.Text := opmC_Def_DBTable_Languages;
  opm_Edit_ConfigDBTable04.Text := opmC_Def_DBTable_Products;
  opm_Edit_ConfigDBTable05.Text := opmC_Def_DBTable_Specials;
  opm_Edit_ConfigDBTable06.Text := opmC_Def_DBTable_ProductsDescription;
  opm_Edit_ConfigDBTable07.Text := opmC_Def_DBTable_TaxClass;
  opm_Edit_ConfigDBTable08.Text := opmC_Def_DBTable_Currencies;
  opm_Edit_ConfigDBTable09.Text := opmC_Def_DBTable_Configuration;
  opm_Edit_ConfigDBTable10.Text := opmC_Def_DBTable_ProductsToCategories;
  opm_Edit_ConfigDBTable11.Text := opmC_Def_DBTable_CategoriesDescription;
  opm_Edit_ConfigDBTable13.Text := opmC_Def_DBTable_TaxRates;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigFontPrintClick(Sender: TObject);
begin
  IF (opm_PRNFontDialog_Config.Execute = TRUE) THEN
    BEGIN
      opm_Label_ConfigPRNFontDetails.Font := opm_PRNFontDialog_Config.Font;
      opm_Label_ConfigPRNFontDetails.Caption := opm_PRNFontDialog_Config.Font.Name + ', ' +
                                             INTTOSTR (ROUND ((opm_PRNFontDialog_Config.Font.Height * -72) / opm_PRNFontDialog_Config.Font.PixelsPerInch)) + ', ' +
                                             opmG_CharsetList [opm_PRNFontDialog_Config.Font.Charset];
    END
  ELSE
    BEGIN
      opm_PRNFontDialog_Config.Font.Name := opmG_PRNFontName;
      opm_PRNFontDialog_Config.Font.Height := ROUND ((opmG_PRNFontSize * opm_PRNFontDialog_Config.Font.PixelsPerInch) / -72);;
      opm_PRNFontDialog_Config.Font.Charset := opmG_PRNFontCharset;
      opm_PRNFontDialog_Config.Font.Style := opmC_Def_PRNFontStyle;
    END;
end;

end.
